(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("rethinkdb"));
	else if(typeof define === 'function' && define.amd)
		define(["rethinkdb"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("rethinkdb")) : factory(root["rethinkdb"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, function(__WEBPACK_EXTERNAL_MODULE_6__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _src = __webpack_require__(1);

	Object.keys(_src).forEach(function (key) {
	  if (key === "default") return;
	  Object.defineProperty(exports, key, {
	    enumerable: true,
	    get: function get() {
	      return _src[key];
	    }
	  });
	});

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _topic = __webpack_require__(2);

	Object.defineProperty(exports, 'Topic', {
	  enumerable: true,
	  get: function get() {
	    return _topic.Topic;
	  }
	});

	var _queue = __webpack_require__(3);

	Object.defineProperty(exports, 'Queue', {
	  enumerable: true,
	  get: function get() {
	    return _queue.Queue;
	  }
	});

	var _exchange = __webpack_require__(4);

	Object.defineProperty(exports, 'Exchange', {
	  enumerable: true,
	  get: function get() {
	    return _exchange.Exchange;
	  }
	});

/***/ },
/* 2 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	// Represents a topic that may be published to

	var Topic = exports.Topic = function () {
	    function Topic(exchange, topicKey) {
	        _classCallCheck(this, Topic);

	        this.exchange = exchange;
	        this.key = topicKey;
	    }

	    // Publish a payload to the current topic


	    _createClass(Topic, [{
	        key: "publish",
	        value: function publish(payload) {
	            return this.exchange.publish(this.key, payload);
	        }
	    }]);

	    return Topic;
	}();

/***/ },
/* 3 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	// A queue that filters messages in the exchange

	var Queue = exports.Queue = function () {
	    function Queue(exchange, filterFunc) {
	        _classCallCheck(this, Queue);

	        this.exchange = exchange;
	        this.filterFunc = filterFunc;
	    }

	    // Returns the full ReQL query for this queue


	    _createClass(Queue, [{
	        key: "fullQuery",
	        value: function fullQuery() {
	            return this.exchange.fullQuery(this.filterFunc);
	        }

	        // Subscribe to messages from this queue's subscriptions

	    }, {
	        key: "subscribe",
	        value: function subscribe(iterFunc) {
	            return this.exchange.subscribe(this.filterFunc, iterFunc);
	        }
	    }]);

	    return Queue;
	}();

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.Exchange = undefined;

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _rethinkdb = __webpack_require__(6);

	var _rethinkdb2 = _interopRequireDefault(_rethinkdb);

	var _topic = __webpack_require__(2);

	var _queue = __webpack_require__(3);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	// Represents a message exchange which messages can be sent to and
	// consumed from. Each exchange has an underlying RethinkDB table.

	var Exchange = exports.Exchange = function () {
	    function Exchange(name) {
	        var _this = this;

	        var connOpts = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

	        _classCallCheck(this, Exchange);

	        this.db = connOpts.db = connOpts.db || 'test';
	        this.name = name;
	        this.conn = null;
	        this.table = _rethinkdb2.default.table(name);
	        this._asserted = false;

	        this.promise = _rethinkdb2.default.connect(connOpts).then(function (conn) {
	            return _this.conn = conn;
	        }).catch(_rethinkdb2.default.Error.RqlRuntimeError, function (err) {
	            console.error(err.message);
	            process.exit(1);
	        });

	        this.assertPromise = this.promise;
	    }

	    // Returns a topic in this exchange


	    _createClass(Exchange, [{
	        key: 'topic',
	        value: function topic(name) {
	            return new _topic.Topic(this, name);
	        }

	        // Returns a new queue on this exchange that will filter messages by
	        // the given query

	    }, {
	        key: 'queue',
	        value: function queue(filterFunc) {
	            return new _queue.Queue(this, filterFunc);
	        }

	        // The full ReQL query for a given filter function

	    }, {
	        key: 'fullQuery',
	        value: function fullQuery(filterFunc) {
	            return this.table.changes()('new_val').filter(function (row) {
	                return filterFunc(row('topic'));
	            });
	        }

	        // Publish a message to this exchange on the given topic

	    }, {
	        key: 'publish',
	        value: function publish(topicKey, payload) {
	            var _this2 = this;

	            return this.assertTable().then(function () {
	                var topIsObj = Object.prototype.toString.call(topicKey) === '[object Object]';
	                var topic = topIsObj ? _rethinkdb2.default.literal(topicKey) : topicKey;
	                return _this2.table.filter({ topic: topic }).update({
	                    payload: payload,
	                    updated_on: _rethinkdb2.default.now() // eslint-disable-line
	                }).run(_this2.conn);
	            }).then(function (updateResult) {
	                // If the topic doesn't exist yet, insert a new document. Note:
	                // it's possible someone else could have inserted it in the
	                // meantime and this would create a duplicate. That's a risk we
	                // take here. The consequence is that duplicated messages may
	                // be sent to the consumer.
	                if (updateResult.replaced === 0) {
	                    return _this2.table.insert({
	                        payload: payload,
	                        topic: topicKey,
	                        updated_on: _rethinkdb2.default.now() // eslint-disable-line
	                    }).run(_this2.conn);
	                }

	                return updateResult;
	            });
	        }

	        // Receives a callback that is called whenever a new message comes in
	        // matching the filter function

	    }, {
	        key: 'subscribe',
	        value: function subscribe(filterFunc, iterFunc) {
	            var _this3 = this;

	            return this.assertTable().then(function () {
	                return _this3.fullQuery(filterFunc).run(_this3.conn);
	            }).then(function (cursor) {
	                return cursor.each(function (err, message) {
	                    if (err) {
	                        throw err;
	                    }

	                    iterFunc(message.topic, message.payload);
	                });
	            });
	        }

	        // Ensures the table specified exists and has the correct primary_key
	        // and durability settings

	    }, {
	        key: 'assertTable',
	        value: function assertTable() {
	            var _this4 = this;

	            return this.assertPromise.then(function () {
	                if (_this4._asserted) {
	                    return undefined;
	                }

	                _this4.assertPromise = _rethinkdb2.default.dbCreate(_this4.db).run(_this4.conn).finally(function () {
	                    return _rethinkdb2.default.db(_this4.db).tableCreate(_this4.name).run(_this4.conn);
	                }).catch(_rethinkdb2.default.Error.RqlRuntimeError, function (err) {
	                    if (err.msg.indexOf('already exists') === -1) {
	                        throw err;
	                    }
	                }).then(function () {
	                    _this4._asserted = true;
	                    _this4.assertPromise = _this4.promise;
	                });

	                return _this4.assertPromise;
	            });
	        }
	    }]);

	    return Exchange;
	}();
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(5)))

/***/ },
/* 5 */
/***/ function(module, exports) {

	// shim for using process in browser

	var process = module.exports = {};
	var queue = [];
	var draining = false;
	var currentQueue;
	var queueIndex = -1;

	function cleanUpNextTick() {
	    draining = false;
	    if (currentQueue.length) {
	        queue = currentQueue.concat(queue);
	    } else {
	        queueIndex = -1;
	    }
	    if (queue.length) {
	        drainQueue();
	    }
	}

	function drainQueue() {
	    if (draining) {
	        return;
	    }
	    var timeout = setTimeout(cleanUpNextTick);
	    draining = true;

	    var len = queue.length;
	    while(len) {
	        currentQueue = queue;
	        queue = [];
	        while (++queueIndex < len) {
	            if (currentQueue) {
	                currentQueue[queueIndex].run();
	            }
	        }
	        queueIndex = -1;
	        len = queue.length;
	    }
	    currentQueue = null;
	    draining = false;
	    clearTimeout(timeout);
	}

	process.nextTick = function (fun) {
	    var args = new Array(arguments.length - 1);
	    if (arguments.length > 1) {
	        for (var i = 1; i < arguments.length; i++) {
	            args[i - 1] = arguments[i];
	        }
	    }
	    queue.push(new Item(fun, args));
	    if (queue.length === 1 && !draining) {
	        setTimeout(drainQueue, 0);
	    }
	};

	// v8 likes predictible objects
	function Item(fun, array) {
	    this.fun = fun;
	    this.array = array;
	}
	Item.prototype.run = function () {
	    this.fun.apply(null, this.array);
	};
	process.title = 'browser';
	process.browser = true;
	process.env = {};
	process.argv = [];
	process.version = ''; // empty string to avoid regexp issues
	process.versions = {};

	function noop() {}

	process.on = noop;
	process.addListener = noop;
	process.once = noop;
	process.off = noop;
	process.removeListener = noop;
	process.removeAllListeners = noop;
	process.emit = noop;

	process.binding = function (name) {
	    throw new Error('process.binding is not supported');
	};

	process.cwd = function () { return '/' };
	process.chdir = function (dir) {
	    throw new Error('process.chdir is not supported');
	};
	process.umask = function() { return 0; };


/***/ },
/* 6 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_6__;

/***/ }
/******/ ])
});
;